1.- Departamento, que en un año concreto, tiene mayor numero de incumplimientos de seguridad.

set serveroutput on
ACCEPT anyo char prompt '¿cual es el anyo del que quieres saber el mayor numero de incumplimientos activos?'
DECLARE
incumplimientos number:=0;
maxincumplimientos number:=0;
previousdepto number:=0;
nombbredep departamento.nombre%TYPE;
BEGIN
  FOR c_dptoincumpanyo IN (SELECT numincumplimientos, incumplimientospoliticas.iddepto, departamento.nombre 
                                    FROM incumplimientospoliticas , departamento
                                    where extract(year from fechregistro)=&anyo and incumplimientospoliticas.iddepto=departamento.iddepto order by iddepto)
    LOOP
        IF (previousdepto <> c_dptoincumpanyo.iddepto) THEN
            incumplimientos:=0;
        END IF;
        incumplimientos:=incumplimientos+c_dptoincumpanyo.numincumplimientos;
        --dbms_output.put_line (c_dptoincumpanyo.numincumplimientos||' '||c_dptoincumpanyo.iddepto);
        --dbms_output.put_line (incumplimientos);
        previousdepto:=c_dptoincumpanyo.iddepto;
        --dbms_output.put_line (previousdepto);
        --dbms_output.put_line (' ');    
        IF (incumplimientos > maxincumplimientos) THEN
            maxincumplimientos:=incumplimientos;
            nombbredep:= c_dptoincumpanyo.nombre;
        END IF;
    END LOOP; 
    IF nombbredep is NULL THEN
        dbms_output.put_line ('No hay departamentos que cumplan dicho criterio en '||&anyo);
    ELSE
        dbms_output.put_line ('El departamento '||nombbredep||' en '||&anyo||' tuvo el maximo numero de incumplimientos... '||maxincumplimientos);
    END IF;
END;



2.- Proceso con mayor numero de vulnerab.
set serveroutput on
DECLARE
  vulnerab number;
  vulnerabmax number;
  procmaxid number;
BEGIN
  vulnerabmax := 0;
  vulnerab :=0;
  FOR c_idproceso IN (select idproceso from procesos)
  LOOP
    -- No nos dejan usar el count(*)
    -- select count(*)
    --   into vulnerab
    --   from maestrovulnerabilidades
    --   where idproceso=c_idproceso.idproceso;
    vulnerab := 0;
    FOR c_count IN (select 1 from maestrovulnerabilidades where idproceso=c_idproceso.idproceso)
        LOOP 
        vulnerab := vulnerab +1;
        END LOOP;
     --dbms_output.put_line ('Resumen con id '||c_idproceso.idproceso||' tiene '||vulnerab||' vulnerabilidades.');
    if vulnerab > vulnerabmax then 
        vulnerabmax := vulnerab;
        procmaxid := c_idproceso.idproceso;
    end if;
  END LOOP;
  IF procmaxid is NULL THEN
    dbms_output.put_line ('No existen procesos con un número máximo de vulnerabilidades.');
  ELSE
    dbms_output.put_line ('El proceso con id '||procmaxid||' tiene '||vulnerabmax||' vulnerabilidades.');
  END IF;
END;

3.-

set serveroutput on
--rem creamos tabla aux
create table AUX as select distinct nombre,apellido1,nif, 0 as suma from empleado;

DECLARE
BEGIN
FOR c_incumplimientos IN (select empl.idempleado, empl.nif, empl.nombre, empl.apellido1, 1 as incumplimientos from empleado empl, incumplimientosempleados incumpl where empl.idempleado=incumpl.idempleado and extract(year from incumpl.fechaincumpl)= extract(year from sysdate)
                          union all
                          select empl.idempleado, empl.nif, empl.nombre, empl.apellido1, incump.numincumplimientos as incumplimientos from empleado empl, departamento dept, incumplimientospoliticas incump where empl.iddepto=dept.iddepto and dept.iddepto=incump.iddepto and extract(year from incump.fechregistro)= extract(year from sysdate))
LOOP
  update AUX set suma = suma + c_incumplimientos.incumplimientos
  where nif = c_incumplimientos.nif;
END LOOP;

dbms_output.put_line ('El top5 de usuarios por numero de incumplimientos seria...');
FOR c_resultado IN (select rownum, nombre, apellido1, suma from (select nombre, apellido1, suma from AUX where suma <> 0 order by suma desc) where rownum<6)
LOOP
  dbms_output.put_line ('En '||c_resultado.rownum||' posicion... '||c_resultado.nombre||' '||c_resultado.apellido1||' con '||c_resultado.suma||' incumplimientos.');
END LOOP;
END;
/

drop table AUX;

4.- Porcentaje de vulnerabilidades que estan totalmente mitigadas 
set serveroutput on
DECLARE
  vulnerabtotal number;
  vulacabadas number;
  contador number;
  completas number;
BEGIN
  vulnerabtotal :=0;
  completas := 0;
  -- No nos dejan usar count(*)
  -- select count(*) into vulnerabtotal from maestrovulnerabilidades;
  FOR c_count IN (select 1 from maestrovulnerabilidades)
  LOOP
    vulnerabtotal := vulnerabtotal+1;
  END LOOP;
  dbms_output.put_line ('Hay '||vulnerabtotal||' vulnerabilidades en total.');
  FOR c_maestrovulnerabilidades IN (select idvulnerabilidad from maestrovulnerabilidades where idestado=4)
  LOOP
    completas:=completas+1;
  END LOOP;
  dbms_output.put_line ('Hay '||completas||' vulnerabilidades acabadas completamente.');
  dbms_output.put_line ('Un '|| round(completas/vulnerabtotal*100, 2) ||'% de las vulnerabilidades totalmente mitigadas.');
END;

5.- Numero de acciones de mitigacion no totalmente acabadas
set serveroutput on
DECLARE
  contador number;
  completas number;
BEGIN
  contador := 0;
  -- No nos dejan usar count(*)
  FOR c_contador IN (select 1 from mitigaciones a, estadosmiti b where a.idestado=b.idestado and b."desc"<>'ACABADA')
  LOOP
    contador := contador+1;
  END LOOP;
  dbms_output.put_line ('Hay '||contador||' mitigaciones NO acabadas completamente.');
END;


6.- Politica de seguridad que ha tenido mas incumplimientos, teniendo en cuenta todos los dptos.

set serveroutput on
DECLARE
  nincumplimientos number;
  nincumplimientosmax number;
  idpoliticamax number;
  shordescripcionmax maestropoliticasseguridad.shortdescripcion%TYPE;
BEGIN
  nincumplimientosmax := 0;
  idpoliticamax := 0;
  FOR c_idpolitica IN (select idpolitica from maestropoliticasseguridad)
  LOOP
    nincumplimientos :=0;
    FOR c_count IN (select incumpl.numincumplimientos, incumpl.idpolitica ,maes.shortdescripcion from incumplimientospoliticas incumpl, maestropoliticasseguridad maes where incumpl.idpolitica=maes.idpolitica and maes.idpolitica=c_idpolitica.idpolitica)
        LOOP 
        nincumplimientos := nincumplimientos + c_count.numincumplimientos;
        --dbms_output.put_line (c_count.shortdescripcion||' '||c_count.numincumplimientos||' '||nincumplimientos);
        IF nincumplimientos > nincumplimientosmax THEN
            nincumplimientosmax := nincumplimientos;
            idpoliticamax := c_count.idpolitica;
            shordescripcionmax := c_count.shortdescripcion;
        END IF;
        END LOOP;
  END LOOP;
  dbms_output.put_line ('La politica de seguridad que ha tenido mas incumplimientos es la que tiene id. '||idpoliticamax||' con descripcion corta '||shordescripcionmax||' y tiene '||nincumplimientosmax||' incumplimientos.');
END;

7.- Dado un dpto, porcentaje de los empleados que no han terminado las acciones formativas asignadas
Las que no han terminado son los estados sin calificar y no presentado. No apto es suspenso pero sí termino la accion formativa, aunque malamente

set serveroutput on
ACCEPT dpto char prompt '¿cual es el nombre del departamento?'
DECLARE
  empleadosdpto number;
  noterminadas number;
BEGIN
  select count(*) into empleadosdpto from empleado, departamento
    where empleado.iddepto = departamento.iddepto 
    and departamento.nombre = '&dpto';
  IF empleadosdpto!=0 THEN
    select count(distinct(empleado.idempleado)) into noterminadas from sesionesformativas, empleado, departamento, notas 
      where sesionesformativas.idempleado = empleado.idempleado 
      and empleado.iddepto = departamento.iddepto 
      and sesionesformativas.idnota = notas.IDNOTA
      and notas."desc" in ('SIN CALIFICAR','NO PRESENTADO')
     and departamento.nombre = '&dpto';
    
    dbms_output.put_line ('Hay '||empleadosdpto||' empleados del departamento');
    dbms_output.put_line ('Hay '||noterminadas||' empleados del departamento que NO han terminado sesiones formativas');
    dbms_output.put_line ( 'El '||round(noterminadas/empleadosdpto*100,2)||'% es el porcentaje de los empleados que no han terminado las acciones formativas asignadas para el departamento');
  ELSE
    dbms_output.put_line ('No hay empleados en ese dpto. o ese depto no existe');
  END IF;
END;

8.- Porcentaje de empleados de la empresa que en este año, no tienen incumplimiento asignado.

set serveroutput on
DECLARE
  numempleados number;
  numempleadosconincumplimientos number;
BEGIN
  numempleados := 0;
  numempleadosconincumplimientos :=0;
  FOR c_contadorempleados IN (select 1 from empleado)
  LOOP
    numempleados := numempleados+1;
  END LOOP;
  FOR c_numempleadosconincumplimientos IN (select distinct idempleado from incumplimientosempleados where extract(year from fechaincumpl)= extract(year from sysdate))
  LOOP
    numempleadosconincumplimientos := numempleadosconincumplimientos+1;
  END LOOP;
  -- Evitamos el caso de divisor 0
  IF (numempleados = 0) THEN
      dbms_output.put_line('No tenemos empleados en BBDD.');
  ELSE 
      dbms_output.put_line ('Hay '||numempleados||' empleados en total.');
      dbms_output.put_line ('De ellos, '||numempleadosconincumplimientos||' cometen incumplimientos.');
      dbms_output.put_line ('Por tanto, un '||((numempleados-numempleadosconincumplimientos)/numempleados*100)||'% no comenten incumplimientos en '||extract(year from sysdate));
  END IF;
END;

9.- Anyo en el cual se han detectado mas incumplimientos por auditorias externas

set serveroutput on
create table AUX (anyo , suma) as select distinct to_number(to_char(res.fechregistro,'YYYY')), 0 from resultadosauditoria res, maestroauditoria maes 
                                        where maes.idtipoauditoria=1 and res.idauditoria=maes.idauditoria;
DECLARE
  numvulnerabilidadesafterleave number;
BEGIN
  numvulnerabilidadesafterleave := 0;
  
  FOR c_incumplimientos IN (select to_number(to_char(res.fechregistro,'YYYY')) as anyo, numincumplimientos from resultadosauditoria res, maestroauditoria maes 
                                        where maes.idtipoauditoria=1 and res.idauditoria=maes.idauditoria)
  LOOP
    update AUX
      set suma = suma + c_incumplimientos.numincumplimientos
      where anyo=c_incumplimientos.anyo;
  END LOOP;

  FOR c_resultados IN (select * from (select * from aux) where rownum<2)
  LOOP
  dbms_output.put_line('El anyo con mas incumplimientos en todas las auditorias externas registradas fue el:'||c_resultados.anyo||' con '||c_resultados.suma||' incumplimientos.');
  END LOOP;
END;
/
drop table AUX;

10.- Porcentaje de vulnerabilidades críticas que no estén acabadas
set serveroutput on
DECLARE
  vulnerabtotal number;
  vulacabadas number;
  contador number;
  completas number;
BEGIN
  vulnerabtotal :=0;
  completas := 0;
  -- No nos dejan usar count(*)
  -- select count(*) into vulnerabtotal from maestrovulnerabilidades;
  -- tratamos solo las criticas
  FOR c_count IN (select 1 from maestrovulnerabilidades vul, importancia impo where vul.idimportancia=impo.idimportancia and impo."desc"='CRITICA')
  LOOP
    vulnerabtotal := vulnerabtotal+1;
  END LOOP;
  dbms_output.put_line ('Hay '||vulnerabtotal||' vulnerabilidades CRITICAS en total.');
  FOR c_maestrovulnerabilidades IN (select vul.idvulnerabilidad from maestrovulnerabilidades vul, importancia impo where vul.idimportancia=impo.idimportancia and impo."desc"='CRITICA')
  LOOP
    contador := 0;
    vulacabadas :=0;
    -- llegan solo las criticas por el c_maestrovulnerabilidades
    FOR c_estadomitigaciones IN (select estadosmiti."desc" from mitigaciones, estadosmiti where idvulnerabilidad=c_maestrovulnerabilidades.idvulnerabilidad and mitigaciones.idestado=estadosmiti.idestado 
                                 and estadosmiti."desc" not in 'ACABADA')
    LOOP
    contador := contador + 1;
    --dbms_output.put_line(c_maestrovulnerabilidades.idvulnerabilidad||' '||c_estadomitigaciones."desc");
    --dbms_output.put_line(vulacabadas||' '||contador);
    END LOOP;
  IF vulacabadas = contador THEN
    completas := completas+1;
  END IF;  
  END LOOP;
  -- restamos a las vulnerabilidades totales las que estan completas
  dbms_output.put_line ('Hay '||(vulnerabtotal-completas)||' vulnerabilidades CRITICAS con alguna accion de mitigacion abierta.');
  dbms_output.put_line ('Un '|| round((vulnerabtotal-completas)/vulnerabtotal*100, 2) ||'% de las vulnerabilidades CRITICAS con alguna accion de mitigacion abierta.');
END;


11.- En el año anterior, título de la sesión telemática que ha tenido menor porcentaje de participantes en total (de esas sesiones telemáticas)

set serveroutput on
--rem creamos tabla aux
create table AUX as select distinct sesiontitulo,0 as suma from maestrosesionesformativas where extract(year from fechainicio)= extract(year from sysdate)-1;

DECLARE
contadornumsesiones number := 0;
contadornumsesionesTOTAL number := 0;
aux number := 0;
aux1 number := 0;
aux2 number := 0;
inicializarsesion number :=0;
contadorminparticipantessesion number := 9999999999999999999;
contadorparticipantestotal number := 0;
titulominparticip maestrosesionesformativas.sesiontitulo%TYPE;
BEGIN
  FOR c_formacionestelematicas IN (select ses.idsesion, ses.sesiontitulo, sess.idempleado from maestrosesionesformativas ses, tipoformacion tipo, sesionesformativas sess 
                                    where ses.idtipoformacion=tipo.idtipoformacion 
                                    and sess.idsesion=ses.idsesion
                                    and tipo."desc"='TELEMATICA' 
                                    and extract(year from ses.fechainicio)= extract(year from sysdate)-1 order by ses.idsesion)
  LOOP
  update AUX set suma = suma + 1
  where sesiontitulo = c_formacionestelematicas.sesiontitulo;
  dbms_output.put_line (c_formacionestelematicas.sesiontitulo||' '||c_formacionestelematicas.idsesion||' '||c_formacionestelematicas.idempleado);

  contadornumsesionesTOTAL:=contadornumsesionesTOTAL+1;
  END LOOP;

  dbms_output.put_line ('');
  dbms_output.put_line ('Hay '||contadornumsesionesTOTAL||' inscritos a las diferentes sesiones de formacion en total.');
  
  FOR c_resultado IN (select * from (select sesiontitulo, suma from AUX where suma <> 0 order by suma asc) where rownum<2)
  LOOP

  dbms_output.put_line ('La sesion con menor porcentaje de participantes es... '||c_resultado.sesiontitulo||' con '||c_resultado.suma||' participantes.');
  dbms_output.put_line (c_resultado.sesiontitulo||' tiene un porcentaje de participacion del '||round((c_resultado.suma/contadornumsesionesTOTAL*100),2)||'% de los inscritos a alguna sesion formativa.');  
  END LOOP;

END;
/

drop table AUX;

12.- Numero de vulnerabilidades criticas que se han detectado internamente posterior a la fecha de cierre del análisis de la empresa externa.
Esa fecha la pasaremos por parámetro.

set serveroutput on
ACCEPT fechaleave char prompt '¿En que fecha finalizo el analisis de la consultora externa? (Formato DD/MM/YYYY)'
DECLARE
  numvulnerabilidadesafterleave number;
BEGIN
  numvulnerabilidadesafterleave := 0;
  
  FOR c_vulnerabilidadesafterleave IN (select 1 from maestrovulnerabilidades maes, importancia imp 
                                        where maes.idimportancia=imp.idimportancia and imp."desc"='CRITICA'
                                        and maes.fechadeteccion > to_date('&fechaleave','DD/MM/YYYY'))
  LOOP
    numvulnerabilidadesafterleave := numvulnerabilidadesafterleave+1;
  END LOOP;

  dbms_output.put_line(numvulnerabilidadesafterleave||' Vulnerabilidades CRITICAS fueron encontradas internamente despues del analisis inicial realizado por la consultora externa, despues del '||to_date('&fechaleave','DD/MM/YYYY'));
END;

13.- porcentaje de acciones de mitigacion en estados "en proceso" o "en revision"

set serveroutput on

DECLARE
  mitigacionestotal number;
  mitigacionesestado number;
BEGIN
  mitigacionesestado := 0;
  mitigacionestotal := 0;
  FOR c_mitigacionestotal IN (select 1 from mitigaciones)
  LOOP
    mitigacionestotal := mitigacionestotal+1;
  END LOOP;
  FOR c_mitigacionesestado IN (select 1 from mitigaciones miti, estadosmiti estado where miti.idestado=estado.idestado and estado."desc" in ('EN PROCESO','EN REVISION'))
  LOOP
    mitigacionesestado := mitigacionesestado+1;
  END LOOP;

  dbms_output.put_line('Hay '||mitigacionestotal||' mitigaciones en total.');
  dbms_output.put_line('Hay '||mitigacionesestado||' mitigaciones en estados "EN PROCESO" o "EN REVISION".');
  dbms_output.put_line('Lo cual supone que hay un '||round((mitigacionesestado/mitigacionestotal*100),2)||'% del total de mitigaciones en estado "EN PROCESO" o "EN REVISION".');
END;

14.- Responsable que mas tiene acciones de mitigacion en proceso. 

set serveroutput on
DECLARE
  acciones number :=0;
  maxacciones number :=0;
  maxidresp mitigaciones.idresponsable%TYPE;
  nombre empleado.nombre%TYPE;
  apellido empleado.apellido1%TYPE;
  
BEGIN

  FOR c_mitigacionesresp IN (select distinct miti.idresponsable from mitigaciones miti, estadosmiti estado where miti.idestado=estado.idestado and estado."desc" in ('EN PROCESO') order by miti.idresponsable)
  LOOP
    -- ahora busco para atras una vez que se los empleados
    FOR c_mitigacionesrespvuelta IN (select miti.idresponsable, emp.nombre, emp.apellido1 
                                from mitigaciones miti, estadosmiti estado, empleado emp 
                                where miti.idestado=estado.idestado and estado."desc" in ('EN PROCESO') 
                                and emp.idempleado=miti.idresponsable
                                and miti.idresponsable=c_mitigacionesresp.idresponsable)
    LOOP
        acciones := acciones+1;
        IF acciones > maxacciones THEN
            maxacciones := acciones;
            maxidresp := c_mitigacionesrespvuelta.idresponsable;
            nombre := c_mitigacionesrespvuelta.nombre;
            apellido := c_mitigacionesrespvuelta.apellido1;
        END IF;
        --dbms_output.put_line(acciones);
    END LOOP;
        acciones :=0;
  END LOOP;

IF maxidresp is not null THEN  
    dbms_output.put_line('El empleado con Id. '||maxidresp||' '||nombre||' '||apellido||' tiene '||maxacciones||' acciones de remediacion "en proceso", es el que mas tiene.' );
ELSE
    dbms_output.put_line('No hay empleados que cumplan los criterios');
END IF;
END;