----
----

prompt creando packages PCK_ABM...

CREATE OR REPLACE PACKAGE PCK_ABM AS
/******************************************************************************
   NOMBRE:   PCK_ABM
   DESCRIPCIoN: PAQUETE DE PROCEDIMIENTOS ABM DE LAS ENTIDADES DE LA BBDD

******************************************************************************/

  /**************************************
   *  MANTENIMIENTO PROCESOS
   **************************************/

  PROCEDURE ALTA_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	pdescripcionproceso IN procesos.descripcionproceso%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	pdescripcionproceso IN procesos.descripcionproceso%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	pdenominacion IN fabricantes.denominacionsocial%TYPE,
  pdatoscontacto IN fabricantes.datoscontacto%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	pdenominacion IN fabricantes.denominacionsocial%TYPE,
  pdatoscontacto IN fabricantes.datoscontacto%TYPE,
	RSP OUT VARCHAR2); 

  PROCEDURE ALTA_DPTO (
	pnombre IN departamento.nombre%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_DPTO (
	pnombre IN departamento.nombre%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_EMPLEADO (
    pNIF IN empleado.nif%TYPE,
	  pnombre IN empleado.nombre%TYPE,
	  papellido1 IN empleado.apellido1%TYPE,
    papellido2 IN empleado.apellido2%TYPE,
    piddepto IN empleado.iddepto%TYPE,
    pfechaalta IN empleado.fechaalta%TYPE,
    pfechabaja IN empleado.fechabaja%TYPE,
    pemail IN empleado.email%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_EMPLEADO (
	pNIF IN empleado.NIF%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_EMPLEADO (
    pNIF IN empleado.nif%TYPE,
	  pnombre IN empleado.nombre%TYPE,
	  papellido1 IN empleado.apellido1%TYPE,
    papellido2 IN empleado.apellido2%TYPE,
    piddepto IN empleado.iddepto%TYPE,
    pfechaalta IN empleado.fechaalta%TYPE,
    pfechabaja IN empleado.fechabaja%TYPE,
    pemail IN empleado.email%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	pidnota IN sesionesformativas.idnota%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
    pagenda IN maestrosesionesformativas.agenda%TYPE,
	  pidtipoformacion IN maestrosesionesformativas.idtipoformacion%TYPE,
    pfechainicio IN maestrosesionesformativas.fechainicio%TYPE,
	pfechafin IN maestrosesionesformativas.fechafin%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
    pagenda IN maestrosesionesformativas.agenda%TYPE,
	  pidtipoformacion IN maestrosesionesformativas.idtipoformacion%TYPE,
    pfechainicio IN maestrosesionesformativas.fechainicio%TYPE,
	pfechafin IN maestrosesionesformativas.fechafin%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_VULNERABILIDAD (
    pnombre IN maestrovulnerabilidades.nombrevulnerabilidad%TYPE,
    pidfabricante IN maestrovulnerabilidades.idfabricante%TYPE,
	  pidproceso IN maestrovulnerabilidades.idproceso%TYPE,
    pidestado IN maestrovulnerabilidades.idestado%TYPE,
	  pcvecode IN maestrovulnerabilidades.cvecode%TYPE,
	  pdescripcion IN maestrovulnerabilidades.descripcion%TYPE,
	  preferencias IN maestrovulnerabilidades.referencias%TYPE,
    pfechadeteccion IN maestrovulnerabilidades.fechadeteccion%TYPE,
    pidimportancia IN maestrovulnerabilidades.idimportancia%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_DATOS_LOOKUP (
    ptable IN user_tables.table_name%TYPE,
    pdatolookup VARCHAR2,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_MITIGACION (
    pidvulnerabilidad IN mitigaciones.idvulnerabilidad%TYPE,
    pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
    pdescripcion IN mitigaciones.descripcion%TYPE,
	  pidresponsable IN mitigaciones.idresponsable%TYPE,
	  pfechalimite IN mitigaciones.fechalimite%TYPE,
    pidestado IN mitigaciones.idestado%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_MITIGACION (
	pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
	RSP OUT VARCHAR2);


  PROCEDURE MODIFICACION_MITIGACION (
    pidvulnerabilidad IN mitigaciones.idvulnerabilidad%TYPE,
    pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
    pdescripcion IN mitigaciones.descripcion%TYPE,
	  pidresponsable IN mitigaciones.idresponsable%TYPE,
	  pfechalimite IN mitigaciones.fechalimite%TYPE,
    pidestado IN mitigaciones.idestado%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
    pdescripcion IN maestropoliticasseguridad.descripcion%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
    pdescripcion IN maestropoliticasseguridad.descripcion%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE ALTA_INCUMPLIMIENTOSPOLITICAS (
    pidpolitica IN incumplimientospoliticas.idpolitica%TYPE,
    piddepto IN incumplimientospoliticas.iddepto%TYPE,
    pnumincumplimientos IN incumplimientospoliticas.numincumplimientos%TYPE,
    pshortcomentarios IN incumplimientospoliticas.shortcomentarios%TYPE,
    pcomentarios IN incumplimientospoliticas.comentarios%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_INCUMPLIMIENTOSPOLITICAS (
    pidpolitica IN incumplimientospoliticas.idpolitica%TYPE,
    pshortcomentarios IN incumplimientospoliticas.shortcomentarios%TYPE,
	RSP OUT VARCHAR2);


  PROCEDURE ALTA_INCUMPLIMIENTOSEMPLEADOS (
    pidempleado IN incumplimientosempleados.idempleado%TYPE,
    pfechaincumpl IN incumplimientosempleados.fechaincumpl%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_INCUMPLIMIENTOSEMPLEADOS (
    pidempleado IN incumplimientosempleados.idempleado%TYPE,
    pfechaincumpl IN incumplimientosempleados.fechaincumpl%TYPE,
	RSP OUT VARCHAR2);

END PCK_ABM;
/

CREATE OR REPLACE PACKAGE BODY PCK_ABM AS

  /******************************************************************************
   NOMBRE:      ALTA_PROCESOS_NEGOCIO
   ******************************************************************************/
   PROCEDURE ALTA_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	pdescripcionproceso IN procesos.descripcionproceso%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'PROCESO DE NEGOCIO: '||upper(pnombreproceso)||', DESCRIPCION: '||upper(pdescripcionproceso);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del proceso no puede ser nulo.';
     IF pnombreproceso IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM procesos
        WHERE (nombreproceso = upper(pnombreproceso))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El nombre del proceso ya esta dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO procesos (nombreproceso, descripcionproceso)
       VALUES (upper(pnombreproceso), upper(pdescripcionproceso));
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_PROCESOS_NEGOCIO;

  /******************************************************************************
   NOMBRE:      BAJA_PROCESOS_NEGOCIO
  ******************************************************************************/
  PROCEDURE BAJA_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'NOMBRE PROCESO: '||pnombreproceso;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del proceso no puede ser nulo.';
     IF pnombreproceso IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que lel nombre de proceso exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM procesos
        WHERE (nombreproceso = upper(pnombreproceso));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El nombre de proceso no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE procesos WHERE nombreproceso = upper(pnombreproceso);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_PROCESOS_NEGOCIO;

  /******************************************************************************
   NOMBRE:      MODIFICACION_PROCESOS_NEGOCIO
   ******************************************************************************/
   PROCEDURE MODIFICACION_PROCESOS_NEGOCIO (
	pnombreproceso IN procesos.nombreproceso%TYPE,
	pdescripcionproceso IN procesos.descripcionproceso%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'PROCESO DE NEGOCIO: '||pnombreproceso||', DESCRIPCION: '||pdescripcionproceso;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del proceso no puede ser nulo.';
     IF pnombreproceso IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la comunidad autonoma exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM procesos
        WHERE nombreproceso = upper(pnombreproceso);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El nombre de proceso no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE procesos 
		SET descripcionproceso = upper(pdescripcionproceso)
     WHERE nombreproceso = upper(pnombreproceso);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_PROCESOS_NEGOCIO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_PROCESOS_NEGOCIO;

  /******************************************************************************
   NOMBRE:      ALTA_FABRICANTE
  ******************************************************************************/
  PROCEDURE ALTA_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	pdenominacion IN fabricantes.denominacionsocial%TYPE,
  pdatoscontacto IN fabricantes.datoscontacto%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'FABRICANTE: '||upper(pnombrefabricante)||', DENOMINACION: '||upper(pdenominacion)||', DATOS CONTACTO: '||upper(pdatoscontacto);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del fabricante no puede ser nulo.';
     IF pnombrefabricante IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el fabricante no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM fabricantes
        WHERE (nombrefabricante = upper(pnombrefabricante))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El nombre del fabricante ya esta dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO fabricantes (nombrefabricante, denominacionsocial, datoscontacto)
       VALUES (upper(pnombrefabricante), upper(pdenominacion), upper(pdatoscontacto));
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_FABRICANTE;

  /******************************************************************************
   NOMBRE:      BAJA_FABRICANTE
  ******************************************************************************/
  PROCEDURE BAJA_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	RSP OUT VARCHAR2) IS
 
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'NOMBRE FABRICANTE: '||pnombrefabricante;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del fabricante no puede ser nulo.';
     IF pnombrefabricante IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que lel nombre de proceso exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM fabricantes
        WHERE (nombrefabricante = upper(pnombrefabricante));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El nombre del fabricante no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE fabricantes WHERE nombrefabricante = upper(pnombrefabricante);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_FABRICANTE;

  /******************************************************************************
   NOMBRE:      MODIFICACION_FABRICANTE
  ******************************************************************************/
  PROCEDURE MODIFICACION_FABRICANTE (
	pnombrefabricante IN fabricantes.nombrefabricante%TYPE,
	pdenominacion IN fabricantes.denominacionsocial%TYPE,
  pdatoscontacto IN fabricantes.datoscontacto%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'NOMBRE FABRICANTE: '||pnombrefabricante;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre de fabricante no puede ser nulo.';
     IF pnombrefabricante IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el fabricante existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM fabricantes
        WHERE nombrefabricante = upper(pnombrefabricante);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El nombre del fabricante no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE fabricantes 
		SET denominacionsocial = upper(pdenominacion),
            datoscontacto = upper(pdatoscontacto)
     WHERE nombrefabricante = upper(pnombrefabricante);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_FABRICANTE', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_FABRICANTE;


  PROCEDURE ALTA_DPTO (
	pnombre IN departamento.nombre%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'DEPARTAMENTO: '||upper(pnombre);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del dpto no puede ser nulo.';
     IF pnombre IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM departamento
        WHERE (nombre = upper(pnombre))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El nombre del dpto ya esta dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO departamento (nombre)
       VALUES (upper(pnombre));
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_DPTO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_DPTO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_DPTO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_DPTO;


  PROCEDURE BAJA_DPTO (
	pnombre IN departamento.nombre%TYPE,
	RSP OUT VARCHAR2) IS
 
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'DEPARTAMENTO: '||pnombre;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre del dpto no puede ser nulo.';
     IF pnombre IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que lel nombre del dpto exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM departamento
        WHERE (nombre = upper(pnombre));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El nombre del dpto no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE departamento WHERE nombre = upper(pnombre);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_DPTO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_DPTO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_DPTO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_DPTO;


  PROCEDURE ALTA_EMPLEADO (
    pNIF IN empleado.nif%TYPE,
	pnombre IN empleado.nombre%TYPE,
	papellido1 IN empleado.apellido1%TYPE,
    papellido2 IN empleado.apellido2%TYPE,
    piddepto IN empleado.iddepto%TYPE,
    pfechaalta IN empleado.fechaalta%TYPE,
    pfechabaja IN empleado.fechabaja%TYPE,
    pemail IN empleado.email%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'EMPLEADO: '||upper(pnombre)||' '||upper(papellido1)||' '||upper(papellido2)||' NIF '||upper(pNIF)||' ID DTO: '||upper(piddepto)||' FECH. ALTA: '||upper(pfechabaja)||' FECH. BAJA: '||upper(pfechabaja);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El NIF del empleado no puede ser nulo.';
     IF pNIF IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El nombre del empleado no puede ser nulo.';
     IF pnombre IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El apellido1 del empleado no puede ser nulo.';
     IF papellido1 IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El depto del empleado no puede ser nulo.';
     IF piddepto IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La fecha de alta del empleado no puede ser nulo.';
     IF pfechaalta IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM empleado
        WHERE (NIF = upper(pNIF))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El empleado ya esta dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;


     -- Se inserta registro en la tabla
     INSERT INTO empleado (iddepto, NIF, nombre, apellido1, apellido2, email, fechaalta, fechabaja)
       VALUES (piddepto, upper(pNIF), upper(pnombre), upper(papellido1), upper(papellido2), upper(pemail), pfechaalta, pfechabaja);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_EMPLEADO;


  PROCEDURE BAJA_EMPLEADO (
	pNIF IN empleado.NIF%TYPE,
	RSP OUT VARCHAR2) IS
 
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'EMPLEADO NIF: '||pNIF;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El NIF del empleado no puede ser nulo.';
     IF pNIF IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el NIF del empleado exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM empleado
        WHERE (NIF = upper(pNIF));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El NIF del empleado no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE empleado WHERE nif = upper(pNIF);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_EMPLEADO;

  PROCEDURE MODIFICACION_EMPLEADO (
    pNIF IN empleado.nif%TYPE,
	pnombre IN empleado.nombre%TYPE,
	papellido1 IN empleado.apellido1%TYPE,
    papellido2 IN empleado.apellido2%TYPE,
    piddepto IN empleado.iddepto%TYPE,
    pfechaalta IN empleado.fechaalta%TYPE,
    pfechabaja IN empleado.fechabaja%TYPE,
    pemail IN empleado.email%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'EMPLEADO: '||upper(pnombre)||' '||upper(papellido1)||' '||upper(papellido2)||' NIF '||upper(pNIF)||' DTO: '||upper(piddepto)||' FECH. ALTA: '||upper(pfechabaja)||' FECH. BAJA: '||upper(pfechabaja);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El NIF del empleado no puede ser nulo.';
     IF pNIF IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El nombre del empleado no puede ser nulo.';
     IF pnombre IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El apellido1 del empleado no puede ser nulo.';
     IF papellido1 IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El depto del empleado no puede ser nulo.';
     IF piddepto IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La fecha de alta del empleado no puede ser nulo.';
     IF pfechaalta IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el empleado existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM empleado
        WHERE NIF = upper(pNIF);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El NIF del empleado no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE empleado 
		SET nombre = upper(pnombre),
            apellido1 = upper(papellido1),
            apellido2 = upper(papellido2),
            fechaalta = pfechaalta,
            fechabaja = pfechabaja,
            email = upper(pemail),
            iddepto = piddepto
     WHERE NIF = upper(pNIF);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_EMPLEADO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_EMPLEADO;



  PROCEDURE ALTA_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	  RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID SESION FORMATIVA: '||pidsesion||' ID EMPLEADO: '||pidempleado;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El ID del empleado no puede ser nulo.';
     IF pidempleado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID de la sesion formativa no puede ser nulo.';
     IF pidsesion IS NULL THEN RAISE E_ERROR; END IF;



     -- Se inserta registro en la tabla
     INSERT INTO sesionesformativas (idempleado, idsesion)
       VALUES (pidempleado, pidsesion);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;
  
  END ALTA_SESIONESFORMATIVAS;


  PROCEDURE BAJA_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID SESION FORMATIVA: '||upper(pidsesion)||' ID EMPLEADO: '||upper(pidsesion);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El ID del empleado no puede ser nulo.';
     IF pidempleado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID de la sesion formativa no puede ser nulo.';
     IF pidsesion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica si el empleado está inscrito a la sesion formativa
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM sesionesformativas
        WHERE idempleado = pidempleado
        AND idsesion = pidsesion;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El ID del empleado no existe en la sesion formativa indicada.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE sesionesformativas WHERE idempleado = pidempleado AND idsesion = pidsesion;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

    END BAJA_SESIONESFORMATIVAS;    

  PROCEDURE MODIFICACION_SESIONESFORMATIVAS (
    pidempleado IN sesionesformativas.idempleado%TYPE,
    pidsesion IN sesionesformativas.idsesion%TYPE,
	pidnota IN sesionesformativas.idnota%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID SESION FORMATIVA: '||upper(pidsesion)||' ID EMPLEADO: '||upper(pidsesion)||' ID NOTA: '||upper(pidnota);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El ID del empleado no puede ser nulo.';
     IF pidempleado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID de la sesion formativa no puede ser nulo.';
     IF pidsesion IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID de la nota no puede ser nulo.';
     IF pidnota IS NULL THEN RAISE E_ERROR; END IF;


     --Si se pasan las pruebas de validacion, se puede actualizar la nota
     BEGIN
	 UPDATE sesionesformativas 
		SET idnota = pidnota
     WHERE idempleado = pidempleado AND idsesion = pidsesion;
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_SESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_SESIONESFORMATIVAS;

  PROCEDURE ALTA_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
    pagenda IN maestrosesionesformativas.agenda%TYPE,
	pidtipoformacion IN maestrosesionesformativas.idtipoformacion%TYPE,
    pfechainicio IN maestrosesionesformativas.fechainicio%TYPE,
	pfechafin IN maestrosesionesformativas.fechafin%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'PROCESO DE NEGOCIO: '||upper(psesiontitulo)||', AGENDA: '||upper(pagenda)||', TIPO FORMACION: '||pidtipoformacion||', INICIO: '||pfechainicio||', FIN: '||pfechafin;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El titulo de la sesion no puede ser nulo.';
     IF psesiontitulo IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El Id del tipo de formacion de la sesion no puede ser nulo.';
     IF pidtipoformacion IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestrosesionesformativas
        WHERE (sesiontitulo = upper(psesiontitulo))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El titulo de la sesion ya esta dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO maestrosesionesformativas (sesiontitulo, agenda, idtipoformacion, fechainicio, fechafin)
       VALUES (upper(psesiontitulo), upper(pagenda), pidtipoformacion, pfechainicio, pfechafin);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_MAESTROSESIONESFORMATIVAS;


  PROCEDURE BAJA_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'SESION FORMATIVA: '||psesiontitulo;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El titulo de la sesion formativa no puede ser nulo.';
     IF psesiontitulo IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la sesion formativa exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestrosesionesformativas
        WHERE (sesiontitulo = upper(psesiontitulo));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La sesion formativa no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE maestrosesionesformativas WHERE sesiontitulo = upper(psesiontitulo);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_MAESTROSESIONESFORMATIVAS;

  PROCEDURE MODIFICACION_MAESTROSESIONESFORMATIVAS (
    psesiontitulo IN maestrosesionesformativas.sesiontitulo%TYPE,
    pagenda IN maestrosesionesformativas.agenda%TYPE,
    pidtipoformacion IN maestrosesionesformativas.idtipoformacion%TYPE,
    pfechainicio IN maestrosesionesformativas.fechainicio%TYPE,
	pfechafin IN maestrosesionesformativas.fechafin%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   coddpto departamento.iddepto%TYPE;

   BEGIN
     PARAM_IN := 'TITULO FORMACION: '||upper(psesiontitulo)||' AGENDA '||upper(pagenda)||' TIPO FORMACION: '||pidtipoformacion||' FECH. INICIO: '||pfechainicio||' FECH. FIN: '||pfechafin;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El titulo de la sesion no puede ser nulo.';
     IF psesiontitulo IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El tipo de formacion no puede ser nulo.';
     IF pidtipoformacion IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el titulo de la formacion existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestrosesionesformativas
        WHERE sesiontitulo = upper(psesiontitulo);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El titulo de la sesion no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE maestrosesionesformativas 
		SET agenda = upper(pagenda),
            idtipoformacion = upper(pidtipoformacion),
            fechainicio = pfechainicio,
            fechafin = pfechafin
     WHERE sesiontitulo = upper(psesiontitulo);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MAESTROSESIONESFORMATIVAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_MAESTROSESIONESFORMATIVAS;

  PROCEDURE ALTA_DATOS_LOOKUP (
    ptable IN user_tables.table_name%TYPE,
    pdatolookup VARCHAR2,
	RSP OUT VARCHAR2) IS 

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'TABLA LOOKUP: '||upper(ptable)||', DATO: '||upper(pdatolookup);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre de la tabla de lookup no puede ser nulo.';
     IF ptable IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El dato a insertar en la tabla de lookup no puede ser nulo.';
     IF pdatolookup IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el la tabla en la que vamos a insertar existe
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM user_tables
        WHERE (table_name = upper(ptable));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La tabla de lookup no existe.';
           RAISE E_ERROR;
     END;

     -- Nos da igual el valor que vamos a insertar en la tabla de lookup ya que lo controlaremos por Oracle con una constraint UNIQUE.

     -- Se inserta registro en la tabla,hemos de cambiar como hacemos el insert ya que no acepta el nombre de tabla como variable
     -- INSERT INTO ptable ("desc")
     --  VALUES (pdatolookup);
     execute immediate 'insert into '||ptable||'("desc") VALUES ('''||upper(pdatolookup)||''')';
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_DATOS_LOOKUP', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_DATOS_LOOKUP', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_DATOS_LOOKUP', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_DATOS_LOOKUP;

  PROCEDURE ALTA_VULNERABILIDAD (
    pnombre IN maestrovulnerabilidades.nombrevulnerabilidad%TYPE,
    pidfabricante IN maestrovulnerabilidades.idfabricante%TYPE,
	pidproceso IN maestrovulnerabilidades.idproceso%TYPE,
    pidestado IN maestrovulnerabilidades.idestado%TYPE,
	pcvecode IN maestrovulnerabilidades.cvecode%TYPE,
	pdescripcion IN maestrovulnerabilidades.descripcion%TYPE,
	preferencias IN maestrovulnerabilidades.referencias%TYPE,
    pfechadeteccion IN maestrovulnerabilidades.fechadeteccion%TYPE,
    pidimportancia IN maestrovulnerabilidades.idimportancia%TYPE,
	RSP OUT VARCHAR2) IS 


   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'VULNERABILIDAD: '||upper(pnombre)||', ID FAB.: '||pidfabricante||', ID PROC.: '||pidproceso||', ID EST.: '||pidestado||',  CVE: '||pcvecode||', DESC: '||pdescripcion||', REF: '||preferencias||', FECHA DETEC: '||pfechadeteccion||', ID IMP.: '||pidimportancia;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El nombre de la vulnerabilidad no puede ser nulo.';
     IF pnombre IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El Id del proceso de empresa no puede ser nulo.';
     IF pidproceso IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El Id fabricante no puede ser nulo.';
     IF pidfabricante IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID de estado no puede ser nulo.';
     IF pidestado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El Id de la importancia no puede ser nulo.';
     IF pidimportancia IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestrovulnerabilidades
        WHERE (nombrevulnerabilidad = upper(pnombre))
          AND ROWNUM  = 1;
        RSP := 'ERROR: Esta vulnerabilidad ya se ha dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO maestrovulnerabilidades (nombrevulnerabilidad, idfabricante, idproceso, idestado, cvecode, descripcion, referencias, fechadeteccion, idimportancia)
       VALUES (upper(pnombre), pidfabricante, pidproceso, pidestado, upper(pcvecode), upper(pdescripcion), upper(preferencias), pfechadeteccion, pidimportancia);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_VULNERABILIDAD', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_VULNERABILIDAD', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_VULNERABILIDAD', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_VULNERABILIDAD;

  PROCEDURE ALTA_MITIGACION (
    pidvulnerabilidad IN mitigaciones.idvulnerabilidad%TYPE,
    pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
    pdescripcion IN mitigaciones.descripcion%TYPE,
	pidresponsable IN mitigaciones.idresponsable%TYPE,
	pfechalimite IN mitigaciones.fechalimite%TYPE,
    pidestado IN mitigaciones.idestado%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'ID VULNERAB.: '||upper(pidvulnerabilidad)||'MITIGACION: '||upper(pshortdescripcion)||'DESCRIPCION: '||upper(pdescripcion)||' ID RESPONSABLE: '||pidresponsable||' FECHA LIM: '||pfechalimite||' ID ESTADO: '||pidestado;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la vulnerabilidad no puede ser nulo.';
     IF pidvulnerabilidad IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La descripcion de la mitigacion no puede ser nulo.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID del responsable no puede ser nulo.';
     IF pidresponsable IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La fecha limite de mitigacion no puede ser nulo.';
     IF pfechalimite IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID del estado no puede ser nulo.';
     IF pidestado IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM mitigaciones
        WHERE (shortdescripcion = upper(pshortdescripcion))
          AND ROWNUM  = 1;
        RSP := 'ERROR: La mitigacion ya ha sido dada de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;


     -- Se inserta registro en la tabla
     INSERT INTO mitigaciones (idvulnerabilidad,shortdescripcion, descripcion, idresponsable, fechalimite, idestado)
       VALUES (pidvulnerabilidad,upper(pshortdescripcion), upper(pdescripcion), pidresponsable, pfechalimite, pidestado);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_MITIGACION;


  PROCEDURE BAJA_MITIGACION (
	pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
	RSP OUT VARCHAR2) IS
 
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'SHORT DESC: '||pshortdescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: La short description no puede ser nula.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el NIF del empleado exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM mitigaciones
        WHERE (shortdescripcion = upper(pshortdescripcion));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: No encontrada la short description no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE mitigaciones WHERE shortdescripcion = upper(pshortdescripcion);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_MITIGACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_MITIGACION;


  PROCEDURE MODIFICACION_MITIGACION (
    pidvulnerabilidad IN mitigaciones.idvulnerabilidad%TYPE,
    pshortdescripcion IN mitigaciones.shortdescripcion%TYPE,
    pdescripcion IN mitigaciones.descripcion%TYPE,
	pidresponsable IN mitigaciones.idresponsable%TYPE,
	pfechalimite IN mitigaciones.fechalimite%TYPE,
    pidestado IN mitigaciones.idestado%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'ID VULNERAB.: '||upper(pidvulnerabilidad)||'MITIGACION: '||upper(pshortdescripcion)||'DESCRIPCION: '||upper(pdescripcion)||' ID RESPONSABLE: '||pidresponsable||' FECHA LIM: '||pfechalimite||' ID ESTADO: '||pidestado;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la vulnerabilidad no puede ser nulo.';
     IF pidvulnerabilidad IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La descripcion de la mitigacion no puede ser nulo.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID del responsable no puede ser nulo.';
     IF pidresponsable IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La fecha limite de mitigacion no puede ser nulo.';
     IF pfechalimite IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El ID del estado no puede ser nulo.';
     IF pidestado IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el titulo de la formacion existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM mitigaciones
        WHERE shortdescripcion = upper(pshortdescripcion);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La mitigacion no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE mitigaciones 
		SET idvulnerabilidad = pidvulnerabilidad,
            descripcion = upper(pdescripcion),
            idresponsable = idresponsable,
            fechalimite = pfechalimite,
            idestado = pidestado
     WHERE shortdescripcion = upper(pshortdescripcion);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_MITIGACION;

  PROCEDURE ALTA_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
    pdescripcion IN maestropoliticasseguridad.descripcion%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN

     PARAM_IN := 'DESCRIPCION CORTA.: '||upper(pshortdescripcion)||' DESCRIPCION : '||upper(pdescripcion);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: La descripcion de la politica no puede ser nulo.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestropoliticasseguridad
        WHERE (shortdescripcion = upper(pshortdescripcion))
          AND ROWNUM  = 1;
        RSP := 'ERROR: La politica ya ha sido dada de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;


     -- Se inserta registro en la tabla
     INSERT INTO maestropoliticasseguridad (shortdescripcion,descripcion)
       VALUES (upper(pshortdescripcion), upper(pdescripcion));
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_MAESTROPOLITICAS;


  PROCEDURE BAJA_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
	RSP OUT VARCHAR2) IS 

 
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'SHORT DESC: '||pshortdescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: La short description no puede ser nula.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el NIF del empleado exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestropoliticasseguridad
        WHERE (shortdescripcion = upper(pshortdescripcion));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: No encontrada la short description no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE maestropoliticasseguridad WHERE shortdescripcion = upper(pshortdescripcion);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_MAESTROPOLITICAS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_MAESTROPOLITICAS;

  PROCEDURE MODIFICACION_MAESTROPOLITICAS (
    pshortdescripcion IN maestropoliticasseguridad.shortdescripcion%TYPE,
    pdescripcion IN maestropoliticasseguridad.descripcion%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'DESCRIPCION CORTA: '||upper(pshortdescripcion)||' DESCRIPCION: '||upper(pdescripcion);


     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: La short description no puede ser nula.';
     IF pshortdescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica si la politica existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM maestropoliticasseguridad
        WHERE shortdescripcion = upper(pshortdescripcion);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La politica no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE maestropoliticasseguridad 
		SET descripcion = upper(pdescripcion)
     WHERE shortdescripcion = upper(pshortdescripcion);
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.MODIFICACION_MITIGACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END MODIFICACION_MAESTROPOLITICAS;

  PROCEDURE ALTA_INCUMPLIMIENTOSPOLITICAS (
    pidpolitica IN incumplimientospoliticas.idpolitica%TYPE,
    piddepto IN incumplimientospoliticas.iddepto%TYPE,
    pnumincumplimientos IN incumplimientospoliticas.numincumplimientos%TYPE,
    pshortcomentarios IN incumplimientospoliticas.shortcomentarios%TYPE,
    pcomentarios IN incumplimientospoliticas.comentarios%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'ID POLITICA.: '||pidpolitica||' ID DEPTO: '||piddepto||' NUM INCUMPLIMIENTOS: '||pnumincumplimientos||' SHORT DESC: '||upper(pshortcomentarios)||' DESC: '||upper(pcomentarios);

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la politica no puede ser nulo.';
     IF pidpolitica IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El departamento asociado a la politica no puede ser nulo.';
     IF piddepto IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: El numero de incumplimientos de la politica no puede ser nulo.';
     IF pnumincumplimientos IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: Descripcion corta de la politica no puede ser nulo.';
     IF pshortcomentarios IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM incumplimientospoliticas
        WHERE (shortcomentarios = upper(pshortcomentarios))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El incumplimiento de la politica ya fue dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;


     -- Se inserta registro en la tabla
     INSERT INTO incumplimientospoliticas (idpolitica,iddepto, numincumplimientos, shortcomentarios, fechregistro, comentarios)
       VALUES (pidpolitica, piddepto, pnumincumplimientos, upper(pshortcomentarios), sysdate, upper(pcomentarios));
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_INCUMPLIMIENTOSPOLITICAS;


  PROCEDURE BAJA_INCUMPLIMIENTOSPOLITICAS (
    pidpolitica IN incumplimientospoliticas.idpolitica%TYPE,
    pshortcomentarios IN incumplimientospoliticas.shortcomentarios%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID POLITICA:'||pidpolitica||' SHORT DESC: '||pshortcomentarios;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la politica no puede ser nulo.';
     IF pidpolitica IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: Descripcion corta de la politica no puede ser nulo.';
     IF pshortcomentarios IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el NIF del empleado exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM incumplimientospoliticas
        WHERE (idpolitica=pidpolitica and shortcomentarios = upper(pshortcomentarios));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: No encontrada la short description no existe para ese id polictica.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE incumplimientospoliticas WHERE idpolitica=pidpolitica and shortcomentarios = upper(pshortcomentarios);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSPOLITICAS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_INCUMPLIMIENTOSPOLITICAS;

  PROCEDURE ALTA_INCUMPLIMIENTOSEMPLEADOS (
    pidempleado IN incumplimientosempleados.idempleado%TYPE,
    pfechaincumpl IN incumplimientosempleados.fechaincumpl%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);


   BEGIN
     PARAM_IN := 'ID EMPLEADO.: '||pidempleado||' FECHA INCUMPL.: '||pfechaincumpl;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El id del empleado que incumple la politica no puede ser nulo.';
     IF pidempleado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: La fecha en el que el empleado incumplio la politica no puede ser nulo.';
     IF pfechaincumpl IS NULL THEN RAISE E_ERROR; END IF;


     --Se verifica que el proceso no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM incumplimientosempleados
        WHERE (idempleado = pidempleado and trunc(fechaincumpl)=trunc(pfechaincumpl))
          AND ROWNUM  = 1;
        RSP := 'ERROR: El incumplimiento por este empleado ya fue dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;


     -- Se inserta registro en la tabla
     INSERT INTO incumplimientosempleados (idempleado, fechaincumpl)
       VALUES (pidempleado, pfechaincumpl);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PCK_ABM.ALTA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PCK_ABM.ALTA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_INCUMPLIMIENTOSEMPLEADOS;

  PROCEDURE BAJA_INCUMPLIMIENTOSEMPLEADOS (
    pidempleado IN incumplimientosempleados.idempleado%TYPE,
    pfechaincumpl IN incumplimientosempleados.fechaincumpl%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID EMPLEADO:'||pidempleado||' FECH. INCUMPLIMIENTO: '||pfechaincumpl;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la politica no puede ser nulo.';
     IF pidempleado IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: Descripcion corta de la politica no puede ser nulo.';
     IF pfechaincumpl IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el NIF del empleado exista en base de datos
     BEGIN
       SELECT distinct 'S'
        INTO EXISTE
        FROM incumplimientosempleados
        WHERE (idempleado = pidempleado and trunc(fechaincumpl)=trunc(pfechaincumpl));
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: No encontrada la short description no existe para ese id polictica.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE incumplimientosempleados WHERE (idempleado = pidempleado and trunc(fechaincumpl)=trunc(pfechaincumpl));
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PCK_ABM.BAJA_INCUMPLIMIENTOSEMPLEADOS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_INCUMPLIMIENTOSEMPLEADOS;

END PCK_ABM;
/

/* Funcion validacion de NIF*/
CREATE OR REPLACE
FUNCTION VALIDANIF ( DNI IN INTEGER,
 letra IN OUT CHAR,
 NIF OUT VARCHAR2)
RETURN BOOLEAN AS
 letrasValidas CHAR(23) := 'TRWAGMYFPDXBNJZSQVHLCKE';
 letraCorrecta CHAR;
 letraLeida CHAR := SUBSTR (letra, 1);
 resto INTEGER;
BEGIN
 resto := DNI MOD 23;
 letraCorrecta := SUBSTR(letrasValidas, resto+1, 1);
 NIF := letraCorrecta;
 IF (letraCorrecta = letraLeida) THEN
 NIF := TO_CHAR(DNI) || letraLeida ;
 RETURN true;
 ELSE
 letra := letraCorrecta;
 RETURN false;
 END IF;
END VALIDANIF;
/


CREATE OR REPLACE PROCEDURE CREA_AUDITORIA (
    prealizadapor IN maestroauditoria.realizadapor%TYPE,
    ptipoauditoria IN maestroauditoria.idtipoauditoria%TYPE,
    pfechainicial IN incumplimientospoliticas.fechregistro%TYPE,
    pfechafinal IN incumplimientospoliticas.fechregistro%TYPE,
	RSP OUT VARCHAR2) IS 

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   pidauditoria maestroauditoria.idauditoria%TYPE;
   BEGIN
     PARAM_IN := 'AUDITORIA REALIZADA POR: '||prealizadapor||' TIPO AUDITORIA: '||ptipoauditoria||' FECHA INICIO AUDIT: '||pfechainicial||' FECHA FIN AUDIT: '||pfechafinal;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: Quien realizo la auditoria no puede ser nulo.';
     IF prealizadapor IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: tipo de auditoria no puede ser nulo.';
     IF ptipoauditoria IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: Ninguna de las fechas del periodo a auditar no puede ser nula.';
     IF pfechainicial IS NULL THEN RAISE E_ERROR; END IF;
     RSP := 'ERROR: Ninguna de las fechas del periodo a auditar no puede ser nula.';
     IF pfechafinal IS NULL THEN RAISE E_ERROR; END IF;

     --Insertamos en el maestro de auditorias la informacion que hemos metido por parametro
     BEGIN
        INSERT INTO maestroauditoria (idtipoauditoria,realizadapor,fecharealizacion) 
            VALUES (ptipoauditoria, prealizadapor, sysdate);
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'CREA_AUDITORIAMAESTRO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

     BEGIN
     select idauditoria into pidauditoria from (select * from (select idauditoria from maestroauditoria order by idauditoria desc) where rownum<2);
     dbms_output.put_line(pidauditoria);
     INSERT INTO resultadosauditoria select idincumplimiento, pidauditoria, idpolitica, iddepto, numincumplimientos, shortcomentarios, fechregistro, comentarios
                                               from incumplimientospoliticas where fechregistro between pfechainicial AND pfechafinal;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'CREA_AUDITORIARESULTADOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'CREA_AUDITORIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'CREA_AUDITORIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END CREA_AUDITORIA;
/



